/*=========================================================

	heap_kernel.h

	q[vƂĎgp郁̈쐬B
	傫̕Ă̂𕡐mۂꍇɗLB
	
	J[l[hpB
	SCEAPIgpĊmہB

=========================================================*/
#ifndef HEAP_H
#define HEAP_H

#include <pspkernel.h>
#include <pspsysmem_kernel.h>
#include "memory/memory.h"
#include "cgerrno.h"

/*=========================================================
	}N
=========================================================*/
#define HEAP_LOW  1
#define HEAP_HIGH 2
#define HEAP_HEADER_SIZE 8 // q[v烁AllocꍇɎw肵TCY肱̃TCY傫mۂBǗp̈B

#ifdef __cplusplus
extern "C" {
#endif

/*=========================================================
	^錾
=========================================================*/
typedef SceUID HeapUID;

/*=========================================================
	֐
=========================================================*/
/*-----------------------------------------------
	heapExCreate
	
	q[vƂĎgp郁̈mہB
	Ǘ̈KvƂ邽߁AmۂTCÝAw肳ꂽTCY__HEAP_MGMTAREA_SIZE傫ȂB
	
	@param: const char *name
		q[vGA̖OB
	
	@param: MemoryPartition partition
		mۂ郁p[eBV
	
	@param: SceSize size
		mۂTCYB
	
	@param: int type
		mۂʒuB
		HEAP_LOW : 󂫃̂AAhX̏mۂB
		HEAP_HIGH: 󂫃̂AAhX̑傫mۂB
	
	@return HeapUID
		q[vg߂̃nhB
	
-----------------------------------------------*/
HeapUID heapExCreate( const char *name, MemoryPartition partition, SceSize size, int type );

/*-----------------------------------------------
	heapCreate
	
	q[vƂĎgp郁̈mہB
	Ǘ̈KvƂ邽߁AmۂTCÝAw肳ꂽTCY__HEAP_MGMTAREA_SIZE傫ȂB
	
	@param: SceSize size
	mۂTCYB
	
	@return HeapUID
		q[vg߂̃nhB
	
-----------------------------------------------*/
HeapUID heapCreate( SceSize size );

/*-----------------------------------------------
	heapDestroy
	
	mۂq[vB
	q[v̈Ŝ邽߁AheapAlloc()Ŋ蓖ĂĂ郁݂ĂA
	킹ĂׂĉB
	śÃq[vmۂAhXɑ΂ăANZXĂ͂ȂB
	
	@param: HeapUID uid
		heapCreate/heapCreateEx̕ԂlB
-----------------------------------------------*/
void heapDestroy( HeapUID uid );

/*-----------------------------------------------
	heapAlloc
	
	q[vKvȃTCY̗eʂ擾B
	Aq[vmۂTCÝAw肵TCYɃwb_TCY(HEAP_HEADER_SIZE)TCYɂȂB
	
	@param: HeapUID uid
		heapCreate/heapExCreate̕ԂlB
	
	@param: SceSize size
		蓖ĂTCYB
	
	@return: void *
		mۂubNw|C^B
-----------------------------------------------*/
void *heapAlloc( HeapUID uid, SceSize size );

/*-----------------------------------------------
	heapCalloc
	
	q[vKvȃTCỸXg[W擾B
	Aq[vmۂTCÝAw肵TCYɃwb_TCY(HEAP_HEADER_SIZE)TCYɂȂB
	heapAlloc()ƓƂ邪AmیɑΏۃubN[NA_قȂB
	
	@param: HeapUID uid
		heapCreate/heapCreateEx̕ԂlB
	
	@param: SceSize size
		蓖ĂTCYB
	
	@return: void *
		mۂubNw|C^B
-----------------------------------------------*/
void *heapCalloc( HeapUID uid, SceSize size );

/*-----------------------------------------------
	heapFree
	
	heapAlloc()ŊmۂubNAėp\ɂB
	ꂽubN͍Ăуq[vƂĎgƂoB
	
	q[v̂̂KvȂꍇheapDestroy()Ăׂ΂悢A
	̏ꍇAmۂĂ郁ubN悤ƂheapFree()ĂԕKv͂ȂB
	heapDestroy()sƁÃq[vmۂĂ郁ubN͑SĉB
	
	
-----------------------------------------------*/
int heapFree( HeapUID uid, void *ptr );

/*-----------------------------------------------
	heapTotalFreeSize
	
	heapCreate()/heapCreateEx()Ŋmۂq[v̈ɁA
	voCg̋󂫗eʂ݂邩ԂB
	1000ƂlԂĂĂA1000oCg̘AeʂłƂ͌ȂB
	500500̋󂫗eʂcĂ̂ȂA100̋󂫗eʂ10cĂ̂ȂB
	
	
	@param: HeapUID uid
		heapCreate/heapCreateEx̕ԂlB
	
	@return: SceSize
		󂫗eʂ̍vB
-----------------------------------------------*/
SceSize heapTotalFreeSize( HeapUID uid );

#ifdef __cplusplus
}
#endif

#endif
